/***********************************************************
		DOMAIN DEFINITIONS
***********************************************************/

DOMAINS
  EXPR            = add(EXPR,EXPR);
		    subtract(EXPR,EXPR);
		    multiply(EXPR,EXPR);
		    divide(EXPR,EXPR);
		    power(EXPR,EXPR);
		    parenthetical(EXPR);
		    number(REAL);
		    variabel(STRING)


  TOK		  = plus();
		    minus();
		    mult();
		    div();
		    power();
		    lpar();
		    rpar();
		    number(REAL);
		    variabel(STRING);
		    nill


DOMAINS
CURSORq	= INTEGER
CURSORTOq 	= t(TOK, CURSORq )
MESSAGE	= STRING
RESULT	= REAL
SOURCE	= STRING
TOKL 		= CURSORTOq*


PREDICATES
expect(CURSORTOq, TOKL, TOKL)
syntax_error(MESSAGE, TOKL)


/***********************************************************
		PARSING PREDICATES
***********************************************************/

PREDICATES
  s_expr(TOKL,TOKL,EXPR)
  s_expr1(TOKL,TOKL,EXPR)
  s_expr5(TOKL,TOKL,EXPR,EXPR)
  s_expr2(TOKL,TOKL,EXPR)
  s_expr6(TOKL,TOKL,EXPR,EXPR)
  s_expr3(TOKL,TOKL,EXPR)
  s_expr7(TOKL,TOKL,EXPR,EXPR)
  s_expr4(TOKL,TOKL,EXPR)

CLAUSES
  s_expr(LL1,LL0,EXPR):-
	s_expr1(LL1,LL0,EXPR).

  s_expr1(LL1,LL0,EXPR_):-
	s_expr2(LL1,LL2,EXPR),
	s_expr5(LL2,LL0,EXPR,EXPR_).

  s_expr2(LL1,LL0,EXPR_):-
	s_expr3(LL1,LL2,EXPR),
	s_expr6(LL2,LL0,EXPR,EXPR_).

  s_expr3(LL1,LL0,EXPR_):-
	s_expr4(LL1,LL2,EXPR),
	s_expr7(LL2,LL0,EXPR,EXPR_).

  s_expr4([t(lpar,_)|LL1],LL0,parenthetical(EXPR)):-!,
	s_expr(LL1,LL2,EXPR),
	expect(t(rpar,_),LL2,LL0).
  s_expr4([t(number(REAL),_)|LL],LL,number(REAL)):-!.
  s_expr4([t(variabel(STRING),_)|LL],LL,variabel(STRING)):-!.
  s_expr4(LL,_,_):-syntax_error(expr4,LL),fail.

  s_expr5([t(plus,_)|LL1],LL0,EXPR,EXPR_):-!,
	s_expr2(LL1,LL2,EXPR1),
	s_expr5(LL2,LL0,add(EXPR,EXPR1),EXPR_).
  s_expr5([t(minus,_)|LL1],LL0,EXPR,EXPR_):-!,
	s_expr2(LL1,LL2,EXPR1),
	s_expr5(LL2,LL0,subtract(EXPR,EXPR1),EXPR_).
  s_expr5(LL,LL,EXPR,EXPR).

  s_expr6([t(mult,_)|LL1],LL0,EXPR,EXPR_):-!,
	s_expr3(LL1,LL2,EXPR1),
	s_expr6(LL2,LL0,multiply(EXPR,EXPR1),EXPR_).
  s_expr6([t(div,_)|LL1],LL0,EXPR,EXPR_):-!,
	s_expr3(LL1,LL2,EXPR1),
	s_expr6(LL2,LL0,divide(EXPR,EXPR1),EXPR_).
  s_expr6(LL,LL,EXPR,EXPR).

  s_expr7([t(power,_)|LL1],LL0,EXPR,power(EXPR,EXPR1)):-!,
	s_expr3(LL1,LL0,EXPR1).
  s_expr7(LL,LL,EXPR,EXPR).


	    
		    


CLAUSES

  expect(TOK, [TOK|L],L).

  syntax_error(_, _).


DOMAINS
  NUMBER_OF_EXTRA_CHARACTERS 	= INTEGER
  NUMBER_OF_SPACES		= INTEGER

PREDICATES
  is_a_space(CHAR)
  scan(CURSORq, SOURCE, TOKL)
  skip_spaces(SOURCE, SOURCE, NUMBER_OF_SPACES)
  string_tokenq(STRING, TOK)
  
CLAUSES
  is_a_space(' ').	
  is_a_space('\t').	
  is_a_space('\n').

  scan(STARTING_POSITION, SOURCE, [t(TOKEN, LOCATION_OF_TOKEN)|TAIL]) :-
	skip_spaces(SOURCE, NEW_SOURCE, NUMBER_OF_SPACES),
	LOCATION_OF_TOKEN = STARTING_POSITION + NUMBER_OF_SPACES,
	fronttoken(NEW_SOURCE, FRONTTOKEN, REST),
	!,

	LOWER_CASE_FRONTTOKEN = FRONTTOKEN,
	
	string_tokenq(LOWER_CASE_FRONTTOKEN, TOKEN),
	str_len(FRONTTOKEN, LENGTH_OF_FRONTTOKEN),
	NEW_STARTING_POSITION = LOCATION_OF_TOKEN + LENGTH_OF_FRONTTOKEN,
	scan(NEW_STARTING_POSITION, REST, TAIL).
  scan(_, _, []).

  skip_spaces(SOURCE, NEW_SOURCE, NUMBER_OF_SPACES) :-
	frontchar(SOURCE, CHAR, SOURCE1),
	is_a_space(CHAR),
	!,
	skip_spaces(SOURCE1, NEW_SOURCE, NUMBER_OF_SPACES_IN_SOURCE1),
	NUMBER_OF_SPACES = NUMBER_OF_SPACES_IN_SOURCE1 + 1.
  skip_spaces(SOURCE, SOURCE, 0).

  string_tokenq("/",	div) :- !.
  string_tokenq("(", 	lpar) :- !.
  string_tokenq("-", 	minus) :- !.
  string_tokenq("+",	plus) :- !.
  string_tokenq("*", 	mult) :- !.

% DEZE toevoegen zodra je een grammar gebruikt  waarin deze voorkomen 
%  string_tokenq(":", 	colon ) :- !.
%  string_tokenq(";", 	semicolon ) :- !.
%  string_tokenq("?", 	interrogation ) :- !.
%  string_tokenq("\"",	quote ) :- !.

  string_tokenq(STRING, 	number(INTEGER)) :- str_int(STRING, INTEGER), !.
  string_tokenq(STRING, 	number(REAL)) :- str_real(STRING, REAL), !.
%  string_tokenq("^", 	power) :- !.
%  string_tokenq("$", 	expo) :- !.
%  string_tokenq("#", 	log) :- !.
%  string_tokenq("@", 	lgn ) :- !.

  string_tokenq(")",	rpar) :- !.
  string_tokenq(STRING, 	variabel(STRING)) :-  !.
  


PREDICATES

parse( TOKL, EXPR )
tokenize( SOURCE, TOKL )


CLAUSES
  
  
%  evaluate_expression3(EXPR,R2) :-
    % write(EXPR),
    %  dlg_Note(EXPR),
    % trap(term_str(SOURCE,TT,EXPR),_,fail),!,
	% dlg_Note(EXPR),
%    trap(evaluate_expression(EXPR,R2),_,fail).
%  evaluate_expression( EXPR, R2 ):-
%  	tokenize( EXPR, TOKENS ),	parse( TOKENS, TERM ),  	!,
%  	calculate2( TERM, R2 ).
%  evaluate_expression( A, A ) :- !.

tokenize(EXPR, TOKENS) :- scan(0, EXPR, TOKENS).
 
 
% deze moet ook dynamisch 
% parse(TOKENS, TERM) :-   	s_sexp(TOKENS, UNUSED_TOKENS, TERM),  	UNUSED_TOKENS = [].



%include "hlptopic.con"
%include "t8w.con"


  parse(TOKENS, TERM) :-   	s_expr(TOKENS, UNUSED_TOKENS, TERM),  	UNUSED_TOKENS = []. 
